using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace ConcurrencySample
{
  partial class CustomersWithDescBO
  {

    #region Component Implementation

    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.IContainer components = null;

    /// <summary> 
    /// Clean up any resources being used.
    /// </summary>
    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
    protected override void Dispose( bool disposing )
    {
      if (disposing && (components != null))
      {
        components.Dispose();
      }
      base.Dispose( disposing );
    }

    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      // 
      // CustomersBO
      // 
      this.QuerySecurityKey = "CustomerView";
      this.RowVersionOrTimestampColumn = "cust_Version";
      this.UpdateConcurrencyType = MicroFour.StrataFrame.Data.ConcurrencyTypeOptions.OptimisticRowVersion;
      this.CheckRulesOnCurrentRow += new MicroFour.StrataFrame.Business.BusinessLayer.CheckRulesOnCurrentRowEventHandler( this.CustomersWithDescBO_CheckRulesOnCurrentRow );
      this.SetDefaultValues += new MicroFour.StrataFrame.Business.BusinessLayer.SetDefaultValuesEventHandler( this.CustomersWithDescBO_SetDefaultValues );

    }

    #endregion


    #region BusinessLayer Overriden Methods & Properties

    /// <summary>
    /// The collection of required fields for the business object.
    /// </summary>
    [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public override RequiredFieldsCollection RequiredFields
    {
      get
      {
        return base.RequiredFields;
      }
      set
      {
        base.RequiredFields = value;
      }
    }

    /// <summary>
    /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
    /// </summary>
    [Browsable( false ), DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public override IBusinessParentRelationship ParentRelationship
    {
      get
      {
        return base.ParentRelationship;
      }
      set
      {
        base.ParentRelationship = value;
      }
    }

    /// <summary>
    /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
    /// </summary>
    protected override String AllFieldNames
    {
      get
      {
        return "[cust_pk],[cust_Company],[cust_Prefix],[cust_FirstName],[cust_MiddleName],[cust_LastName],[cust_Suffix],[cust_Address1],[cust_Address2],[cust_City],[cust_State],[cust_Postal],[cust_Country],[cust_Email],[cust_PhoneDay],[cust_PhoneDayType],[cust_PhoneNight],[cust_PhoneNightType],[cust_Created],[cust_Version],[cust_InitialPurchaseDate]";
      }
    }

    /// <summary>
    /// The name of the database that contains the table to which this business object is mapped.
    /// </summary>
    public override String Database
    {
      get
      {
        return "StrataFrameSample";
      }
    }

    private static string[] _PrimaryKeyFields = new string[] { "cust_pk" };
    /// <summary>
    /// Gets the field or fields that comprise the primary key for the business object.
    /// </summary>
    public override string[] PrimaryKeyFields
    {
      get
      {
        return _PrimaryKeyFields;
      }
    }

    /// <summary>
    /// The name of the table in the database to which this business object is mapped.
    /// </summary>
    public override String TableName
    {
      get
      {
        return "Customers";
      }
    }

    /// <summary>
    /// The schema of the table in the database to which this business object is mapped.
    /// </summary>
    public override String TableSchema
    {
      get
      {
        return "dbo";
      }
    }

    /// <summary>
    /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
    /// </summary>
    protected override DataColumn[] CreateTableSchema()
    {
      return new DataColumn[] {
new DataColumn("cust_pk", typeof(System.Int32)),
new DataColumn("cust_Company", typeof(System.String)),
new DataColumn("cust_Prefix", typeof(System.String)),
new DataColumn("cust_FirstName", typeof(System.String)),
new DataColumn("cust_MiddleName", typeof(System.String)),
new DataColumn("cust_LastName", typeof(System.String)),
new DataColumn("cust_Suffix", typeof(System.String)),
new DataColumn("cust_Address1", typeof(System.String)),
new DataColumn("cust_Address2", typeof(System.String)),
new DataColumn("cust_City", typeof(System.String)),
new DataColumn("cust_State", typeof(System.String)),
new DataColumn("cust_Postal", typeof(System.String)),
new DataColumn("cust_Country", typeof(System.String)),
new DataColumn("cust_Email", typeof(System.String)),
new DataColumn("cust_PhoneDay", typeof(System.String)),
new DataColumn("cust_PhoneDayType", typeof(System.Int32)),
new DataColumn("cust_PhoneNight", typeof(System.String)),
new DataColumn("cust_PhoneNightType", typeof(System.Int32)),
new DataColumn("cust_Created", typeof(System.DateTime)),
new DataColumn("cust_Version", typeof(System.Int32)),
new DataColumn("cust_InitialPurchaseDate", typeof(System.DateTime))};
    }

    /// <summary>
    /// Adds a broken rule to the business object's collection
    /// </summary>
    protected void AddBrokenRule( CustomersWithDescBOFieldNames Field, string ErrorMessage )
    {
      base.AddBrokenRule( Field, ErrorMessage );
    }

    /// <summary>
    /// Adds a broken rule to the business object's collection
    /// </summary>
    protected new void AddBrokenRule( string FieldName, string ErrorMessage )
    {
      base.AddBrokenRule( FieldName, ErrorMessage );
    }

    /// <summary>
    /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
    /// </summary>
    protected void AddBrokenRuleByKey( CustomersWithDescBOFieldNames Field, string ErrorMessageKey )
    {
      base.AddBrokenRuleByKey( Field, ErrorMessageKey );
    }

    /// <summary>
    /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
    /// </summary>
    protected new void AddBrokenRuleByKey( string FieldName, string ErrorMessageKey )
    {
      base.AddBrokenRuleByKey( FieldName, ErrorMessageKey );
    }

    /// <summary>
    /// Gets a collection of the names for all fields that belong to this business object and map to the database.
    /// </summary>
    public override List<string> AllFieldsList
    {
      get
      {
        return _AllFieldsList;
      }
    }

    /// <summary>
    /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
    /// </summary>
    public override Dictionary<string, DbType> FieldDbTypes
    {
      get
      {
        return _FieldDbTypes;
      }
    }

    /// <summary>
    /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
    /// </summary>
    public override BusinessLayerFieldEnumDictionary FieldEnums
    {
      get
      {
        return _FieldEnums;
      }
    }

    /// <summary>
    /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
    /// </summary>
    public override Dictionary<string, int> FieldLengths
    {
      get
      {
        return _FieldLengths;
      }
    }

    /// <summary>
    /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
    /// </summary>
    public override Dictionary<string, int> FieldNativeDbTypes
    {
      get
      {
        return _FieldNativeDbTypes;
      }
    }

    /// <summary>
    /// Gets a dictionary of the security permission keys for each field in the business object.
    /// </summary>
    public override Dictionary<string, string> FieldPermissionKeys
    {
      get
      {
        return _FieldPermissionKeys;
      }
    }

    #endregion

    #region Field Properties

    /// <summary>
    /// Unique ID (System ID)
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Unique ID (System ID)" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.Int32 cust_pk
    {
      get
      {
        return (System.Int32)this.CurrentRow["cust_pk"];
      }
      set
      {
        this.CurrentRow["cust_pk"] = value;
      }
    }

    /// <summary>
    /// Company
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Company" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Company
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Company"];
      }
      set
      {
        this.CurrentRow["cust_Company"] = value;
      }
    }

    /// <summary>
    /// Salutation
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Salutation" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Prefix
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Prefix"];
      }
      set
      {
        this.CurrentRow["cust_Prefix"] = value;
      }
    }

    /// <summary>
    /// First Name
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "First Name" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_FirstName
    {
      get
      {
        return (System.String)this.CurrentRow["cust_FirstName"];
      }
      set
      {
        this.CurrentRow["cust_FirstName"] = value;
      }
    }

    /// <summary>
    /// Middle Name
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Middle Name" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_MiddleName
    {
      get
      {
        return (System.String)this.CurrentRow["cust_MiddleName"];
      }
      set
      {
        this.CurrentRow["cust_MiddleName"] = value;
      }
    }

    /// <summary>
    /// Last Name
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Last Name" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_LastName
    {
      get
      {
        return (System.String)this.CurrentRow["cust_LastName"];
      }
      set
      {
        this.CurrentRow["cust_LastName"] = value;
      }
    }

    /// <summary>
    /// Last Name Suffix
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Last Name Suffix" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Suffix
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Suffix"];
      }
      set
      {
        this.CurrentRow["cust_Suffix"] = value;
      }
    }

    /// <summary>
    /// Address 1
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Address 1" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Address1
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Address1"];
      }
      set
      {
        this.CurrentRow["cust_Address1"] = value;
      }
    }

    /// <summary>
    /// Address 2
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Address 2" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Address2
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Address2"];
      }
      set
      {
        this.CurrentRow["cust_Address2"] = value;
      }
    }

    /// <summary>
    /// City
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "City" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_City
    {
      get
      {
        return (System.String)this.CurrentRow["cust_City"];
      }
      set
      {
        this.CurrentRow["cust_City"] = value;
      }
    }

    /// <summary>
    /// State
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "State" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_State
    {
      get
      {
        return (System.String)this.CurrentRow["cust_State"];
      }
      set
      {
        this.CurrentRow["cust_State"] = value;
      }
    }

    /// <summary>
    /// ZIP
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "ZIP" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Postal
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Postal"];
      }
      set
      {
        this.CurrentRow["cust_Postal"] = value;
      }
    }

    /// <summary>
    /// Country
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Country" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Country
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Country"];
      }
      set
      {
        this.CurrentRow["cust_Country"] = value;
      }
    }

    /// <summary>
    /// Email
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Email" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_Email
    {
      get
      {
        return (System.String)this.CurrentRow["cust_Email"];
      }
      set
      {
        this.CurrentRow["cust_Email"] = value;
      }
    }

    /// <summary>
    /// Daytime Phone Number
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Daytime Phone Number" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_PhoneDay
    {
      get
      {
        return (System.String)this.CurrentRow["cust_PhoneDay"];
      }
      set
      {
        this.CurrentRow["cust_PhoneDay"] = value;
      }
    }

    /// <summary>
    /// Daytime Phone Type
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Daytime Phone Type" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.Int32 cust_PhoneDayType
    {
      get
      {
        return (System.Int32)this.CurrentRow["cust_PhoneDayType"];
      }
      set
      {
        this.CurrentRow["cust_PhoneDayType"] = value;
      }
    }

    /// <summary>
    /// Nighttime Phone Number
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Nighttime Phone Number" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.String cust_PhoneNight
    {
      get
      {
        return (System.String)this.CurrentRow["cust_PhoneNight"];
      }
      set
      {
        this.CurrentRow["cust_PhoneNight"] = value;
      }
    }

    /// <summary>
    /// Nighttime Phone Type
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Nighttime Phone Type" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.Int32 cust_PhoneNightType
    {
      get
      {
        return (System.Int32)this.CurrentRow["cust_PhoneNightType"];
      }
      set
      {
        this.CurrentRow["cust_PhoneNightType"] = value;
      }
    }

    /// <summary>
    /// Date Created (System Field)
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Date Created (System Field)" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.DateTime cust_Created
    {
      get
      {
        return (System.DateTime)this.CurrentRow["cust_Created"];
      }
      set
      {
        this.CurrentRow["cust_Created"] = value;
      }
    }

    /// <summary>
    /// Concurrency ID (System Field)
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Concurrency ID (System Field)" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.Int32 cust_Version
    {
      get
      {
        return (System.Int32)this.CurrentRow["cust_Version"];
      }
      set
      {
        this.CurrentRow["cust_Version"] = value;
      }
    }

    /// <summary>
    /// Initial Purchase Date
    /// </summary>
    [Browsable( false ),
     BusinessFieldDisplayInEditor(),
     Description( "Initial Purchase Date" ),
     DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
    public System.DateTime cust_InitialPurchaseDate
    {
      get
      {
        object loValue;
        loValue = this.CurrentRow["cust_InitialPurchaseDate"];
        if (loValue == DBNull.Value)
        {
          return new DateTime( 1800, 1, 1 );
        }
        else
        {
          return (System.DateTime)loValue;
        }
      }
      set
      {
        if (value != new DateTime( 1800, 1, 1 ))
        {
          this.CurrentRow["cust_InitialPurchaseDate"] = value;
        }
        else
        {
          this.CurrentRow["cust_InitialPurchaseDate"] = DBNull.Value;
        }
      }
    }

    #endregion

    #region Field Property Events

    #endregion

    #region Nested Types & Field Security

    /// <summary>
    /// Contains all of the field names that belong to the business object.
    /// </summary>
    public enum CustomersWithDescBOFieldNames
    {
      cust_pk,
      cust_Company,
      cust_Prefix,
      cust_FirstName,
      cust_MiddleName,
      cust_LastName,
      cust_Suffix,
      cust_Address1,
      cust_Address2,
      cust_City,
      cust_State,
      cust_Postal,
      cust_Country,
      cust_Email,
      cust_PhoneDay,
      cust_PhoneDayType,
      cust_PhoneNight,
      cust_PhoneNightType,
      cust_Created,
      cust_Version,
      cust_InitialPurchaseDate,
      CUSTOM_FIELD
    }

    /// <summary>
    /// Gets the System.Type of the enumeration that contains the field names for the business object.
    /// </summary>
    public override System.Type GetFieldEnumType()
    {
      return typeof( CustomersWithDescBOFieldNames );
    }

    /// <summary>
    /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
    /// </summary>
    protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs( System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm )
    {
      return new CheckFieldSecurityEventArgs<CustomersWithDescBOFieldNames>( Field, CustomField, PermissionKey, Perm );
    }

    /// <summary>
    /// Describes a method that will handle the CheckFieldScurity event.
    /// </summary>
    public delegate void CheckFieldSecurityEventHandler( object sender, CheckFieldSecurityEventArgs<CustomersWithDescBOFieldNames> e );

    /// <summary>
    /// Occurs when the business objects needs to check the security on a field.
    /// </summary>
    public event CheckFieldSecurityEventHandler CheckFieldSecurity;

    /// <summary>
    /// Raises the CheckFieldSecurity event.
    /// </summary>
    protected override void OnCheckFieldSecurity( CheckFieldSecurityEventArgsBase e )
    {
      if (this.CheckFieldSecurity != null)
      {
        this.CheckFieldSecurity( this, (CheckFieldSecurityEventArgs<CustomersWithDescBOFieldNames>)e );
      }
    }

    #endregion

    #region Item Property Implementation


    private static List<string> _AllFieldsList;
    private static Dictionary<string, DbType> _FieldDbTypes;
    private static BusinessLayerFieldEnumDictionary _FieldEnums;
    private static Dictionary<string, int> _FieldLengths;
    private static Dictionary<string, int> _FieldNativeDbTypes;
    private static Dictionary<string, string> _FieldPermissionKeys;

    /// <summary>
    /// Initializes the static members of the CustomersWithDescBO class.
    /// </summary>
    static CustomersWithDescBO()
    {
      //-- Create the new shared dictionary and populate it with an 
      //   instance of each property descriptor
      _PropertyDescriptors = new PropertyDescriptorDictionary( 26 );
      _PropertyDescriptors.Add( "cust_pk", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_pk, typeof( System.Int32 ) ) );
      _PropertyDescriptors.Add( "cust_Company", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Company, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Prefix", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Prefix, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_FirstName", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_FirstName, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_MiddleName", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_MiddleName, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_LastName", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_LastName, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Suffix", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Suffix, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Address1", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Address1, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Address2", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Address2, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_City", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_City, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_State", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_State, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Postal", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Postal, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Country", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Country, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_Email", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Email, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_PhoneDay", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_PhoneDay, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_PhoneDayType", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_PhoneDayType, typeof( System.Int32 ) ) );
      _PropertyDescriptors.Add( "cust_PhoneNight", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_PhoneNight, typeof( System.String ) ) );
      _PropertyDescriptors.Add( "cust_PhoneNightType", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_PhoneNightType, typeof( System.Int32 ) ) );
      _PropertyDescriptors.Add( "cust_Created", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Created, typeof( System.DateTime ) ) );
      _PropertyDescriptors.Add( "cust_Version", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_Version, typeof( System.Int32 ) ) );
      _PropertyDescriptors.Add( "cust_InitialPurchaseDate", new FieldDescriptor( CustomersWithDescBOFieldNames.cust_InitialPurchaseDate, typeof( System.DateTime ) ) );

      _AllFieldsList = new List<string>( 21 );
      _AllFieldsList.Add( "cust_pk" );
      _AllFieldsList.Add( "cust_Company" );
      _AllFieldsList.Add( "cust_Prefix" );
      _AllFieldsList.Add( "cust_FirstName" );
      _AllFieldsList.Add( "cust_MiddleName" );
      _AllFieldsList.Add( "cust_LastName" );
      _AllFieldsList.Add( "cust_Suffix" );
      _AllFieldsList.Add( "cust_Address1" );
      _AllFieldsList.Add( "cust_Address2" );
      _AllFieldsList.Add( "cust_City" );
      _AllFieldsList.Add( "cust_State" );
      _AllFieldsList.Add( "cust_Postal" );
      _AllFieldsList.Add( "cust_Country" );
      _AllFieldsList.Add( "cust_Email" );
      _AllFieldsList.Add( "cust_PhoneDay" );
      _AllFieldsList.Add( "cust_PhoneDayType" );
      _AllFieldsList.Add( "cust_PhoneNight" );
      _AllFieldsList.Add( "cust_PhoneNightType" );
      _AllFieldsList.Add( "cust_Created" );
      _AllFieldsList.Add( "cust_Version" );
      _AllFieldsList.Add( "cust_InitialPurchaseDate" );

      _FieldDbTypes = new Dictionary<string, DbType>( 21 );
      _FieldDbTypes.Add( "cust_pk", DbType.Int32 );
      _FieldDbTypes.Add( "cust_Company", DbType.String );
      _FieldDbTypes.Add( "cust_Prefix", DbType.String );
      _FieldDbTypes.Add( "cust_FirstName", DbType.String );
      _FieldDbTypes.Add( "cust_MiddleName", DbType.String );
      _FieldDbTypes.Add( "cust_LastName", DbType.String );
      _FieldDbTypes.Add( "cust_Suffix", DbType.String );
      _FieldDbTypes.Add( "cust_Address1", DbType.String );
      _FieldDbTypes.Add( "cust_Address2", DbType.String );
      _FieldDbTypes.Add( "cust_City", DbType.String );
      _FieldDbTypes.Add( "cust_State", DbType.String );
      _FieldDbTypes.Add( "cust_Postal", DbType.AnsiString );
      _FieldDbTypes.Add( "cust_Country", DbType.String );
      _FieldDbTypes.Add( "cust_Email", DbType.AnsiString );
      _FieldDbTypes.Add( "cust_PhoneDay", DbType.AnsiString );
      _FieldDbTypes.Add( "cust_PhoneDayType", DbType.Int32 );
      _FieldDbTypes.Add( "cust_PhoneNight", DbType.AnsiString );
      _FieldDbTypes.Add( "cust_PhoneNightType", DbType.Int32 );
      _FieldDbTypes.Add( "cust_Created", DbType.DateTime );
      _FieldDbTypes.Add( "cust_Version", DbType.Int32 );
      _FieldDbTypes.Add( "cust_InitialPurchaseDate", DbType.DateTime );

      _FieldEnums = new BusinessLayerFieldEnumDictionary( 22 );
      _FieldEnums.Add( "cust_pk", CustomersWithDescBOFieldNames.cust_pk );
      _FieldEnums.Add( "cust_Company", CustomersWithDescBOFieldNames.cust_Company );
      _FieldEnums.Add( "cust_Prefix", CustomersWithDescBOFieldNames.cust_Prefix );
      _FieldEnums.Add( "cust_FirstName", CustomersWithDescBOFieldNames.cust_FirstName );
      _FieldEnums.Add( "cust_MiddleName", CustomersWithDescBOFieldNames.cust_MiddleName );
      _FieldEnums.Add( "cust_LastName", CustomersWithDescBOFieldNames.cust_LastName );
      _FieldEnums.Add( "cust_Suffix", CustomersWithDescBOFieldNames.cust_Suffix );
      _FieldEnums.Add( "cust_Address1", CustomersWithDescBOFieldNames.cust_Address1 );
      _FieldEnums.Add( "cust_Address2", CustomersWithDescBOFieldNames.cust_Address2 );
      _FieldEnums.Add( "cust_City", CustomersWithDescBOFieldNames.cust_City );
      _FieldEnums.Add( "cust_State", CustomersWithDescBOFieldNames.cust_State );
      _FieldEnums.Add( "cust_Postal", CustomersWithDescBOFieldNames.cust_Postal );
      _FieldEnums.Add( "cust_Country", CustomersWithDescBOFieldNames.cust_Country );
      _FieldEnums.Add( "cust_Email", CustomersWithDescBOFieldNames.cust_Email );
      _FieldEnums.Add( "cust_PhoneDay", CustomersWithDescBOFieldNames.cust_PhoneDay );
      _FieldEnums.Add( "cust_PhoneDayType", CustomersWithDescBOFieldNames.cust_PhoneDayType );
      _FieldEnums.Add( "cust_PhoneNight", CustomersWithDescBOFieldNames.cust_PhoneNight );
      _FieldEnums.Add( "cust_PhoneNightType", CustomersWithDescBOFieldNames.cust_PhoneNightType );
      _FieldEnums.Add( "cust_Created", CustomersWithDescBOFieldNames.cust_Created );
      _FieldEnums.Add( "cust_Version", CustomersWithDescBOFieldNames.cust_Version );
      _FieldEnums.Add( "cust_InitialPurchaseDate", CustomersWithDescBOFieldNames.cust_InitialPurchaseDate );
      _FieldEnums.Add( "CUSTOM_FIELD", CustomersWithDescBOFieldNames.CUSTOM_FIELD );

      _FieldLengths = new Dictionary<string, int>( 21 );
      _FieldLengths.Add( "cust_pk", 0 );
      _FieldLengths.Add( "cust_Company", 150 );
      _FieldLengths.Add( "cust_Prefix", 20 );
      _FieldLengths.Add( "cust_FirstName", 60 );
      _FieldLengths.Add( "cust_MiddleName", 60 );
      _FieldLengths.Add( "cust_LastName", 60 );
      _FieldLengths.Add( "cust_Suffix", 20 );
      _FieldLengths.Add( "cust_Address1", 150 );
      _FieldLengths.Add( "cust_Address2", 150 );
      _FieldLengths.Add( "cust_City", 60 );
      _FieldLengths.Add( "cust_State", 128 );
      _FieldLengths.Add( "cust_Postal", 20 );
      _FieldLengths.Add( "cust_Country", 120 );
      _FieldLengths.Add( "cust_Email", 100 );
      _FieldLengths.Add( "cust_PhoneDay", 20 );
      _FieldLengths.Add( "cust_PhoneDayType", 0 );
      _FieldLengths.Add( "cust_PhoneNight", 20 );
      _FieldLengths.Add( "cust_PhoneNightType", 0 );
      _FieldLengths.Add( "cust_Created", 0 );
      _FieldLengths.Add( "cust_Version", 0 );
      _FieldLengths.Add( "cust_InitialPurchaseDate", 0 );

      _FieldNativeDbTypes = new Dictionary<string, int>( 21 );
      _FieldNativeDbTypes.Add( "cust_pk", (int)System.Data.SqlDbType.Int );
      _FieldNativeDbTypes.Add( "cust_Company", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Prefix", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_FirstName", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_MiddleName", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_LastName", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Suffix", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Address1", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Address2", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_City", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_State", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Postal", (int)System.Data.SqlDbType.VarChar );
      _FieldNativeDbTypes.Add( "cust_Country", (int)System.Data.SqlDbType.NVarChar );
      _FieldNativeDbTypes.Add( "cust_Email", (int)System.Data.SqlDbType.VarChar );
      _FieldNativeDbTypes.Add( "cust_PhoneDay", (int)System.Data.SqlDbType.VarChar );
      _FieldNativeDbTypes.Add( "cust_PhoneDayType", (int)System.Data.SqlDbType.Int );
      _FieldNativeDbTypes.Add( "cust_PhoneNight", (int)System.Data.SqlDbType.VarChar );
      _FieldNativeDbTypes.Add( "cust_PhoneNightType", (int)System.Data.SqlDbType.Int );
      _FieldNativeDbTypes.Add( "cust_Created", (int)System.Data.SqlDbType.DateTime );
      _FieldNativeDbTypes.Add( "cust_Version", (int)System.Data.SqlDbType.Int );
      _FieldNativeDbTypes.Add( "cust_InitialPurchaseDate", (int)System.Data.SqlDbType.DateTime );

      _FieldPermissionKeys = new Dictionary<string, string>( 21 );

    }

    private static bool _AreCustomDescriptorsEvaluated = false;
    protected override bool AreCustomDescriptorsEvaluated
    {
      get
      {
        bool llReturn = _AreCustomDescriptorsEvaluated;
        _AreCustomDescriptorsEvaluated = true;
        return llReturn;
      }
    }

    private static PropertyDescriptorDictionary _PropertyDescriptors;
    protected override PropertyDescriptorDictionary PropertyDescriptors
    {
      get
      {
        return _PropertyDescriptors;
      }
    }

    /// <summary>
    /// A PropertyDescriptor class used to Get and Set the value of fields within the CustomersWithDescBO business object.
    /// </summary>
    private class FieldDescriptor :
    MicroFour.StrataFrame.Business.FieldPropertyDescriptor<CustomersWithDescBOFieldNames>
    {
      public FieldDescriptor( CustomersWithDescBOFieldNames field, Type fieldType ) :
        base( field, fieldType ) { }
      private static Type _ComponentType = typeof( CustomersWithDescBO );
      public override object GetValue( object component )
      {
        switch (this.Field)
        {
          case CustomersWithDescBOFieldNames.cust_pk:
            return ((CustomersWithDescBO)component).cust_pk;
          case CustomersWithDescBOFieldNames.cust_Company:
            return ((CustomersWithDescBO)component).cust_Company;
          case CustomersWithDescBOFieldNames.cust_Prefix:
            return ((CustomersWithDescBO)component).cust_Prefix;
          case CustomersWithDescBOFieldNames.cust_FirstName:
            return ((CustomersWithDescBO)component).cust_FirstName;
          case CustomersWithDescBOFieldNames.cust_MiddleName:
            return ((CustomersWithDescBO)component).cust_MiddleName;
          case CustomersWithDescBOFieldNames.cust_LastName:
            return ((CustomersWithDescBO)component).cust_LastName;
          case CustomersWithDescBOFieldNames.cust_Suffix:
            return ((CustomersWithDescBO)component).cust_Suffix;
          case CustomersWithDescBOFieldNames.cust_Address1:
            return ((CustomersWithDescBO)component).cust_Address1;
          case CustomersWithDescBOFieldNames.cust_Address2:
            return ((CustomersWithDescBO)component).cust_Address2;
          case CustomersWithDescBOFieldNames.cust_City:
            return ((CustomersWithDescBO)component).cust_City;
          case CustomersWithDescBOFieldNames.cust_State:
            return ((CustomersWithDescBO)component).cust_State;
          case CustomersWithDescBOFieldNames.cust_Postal:
            return ((CustomersWithDescBO)component).cust_Postal;
          case CustomersWithDescBOFieldNames.cust_Country:
            return ((CustomersWithDescBO)component).cust_Country;
          case CustomersWithDescBOFieldNames.cust_Email:
            return ((CustomersWithDescBO)component).cust_Email;
          case CustomersWithDescBOFieldNames.cust_PhoneDay:
            return ((CustomersWithDescBO)component).cust_PhoneDay;
          case CustomersWithDescBOFieldNames.cust_PhoneDayType:
            return ((CustomersWithDescBO)component).cust_PhoneDayType;
          case CustomersWithDescBOFieldNames.cust_PhoneNight:
            return ((CustomersWithDescBO)component).cust_PhoneNight;
          case CustomersWithDescBOFieldNames.cust_PhoneNightType:
            return ((CustomersWithDescBO)component).cust_PhoneNightType;
          case CustomersWithDescBOFieldNames.cust_Created:
            return ((CustomersWithDescBO)component).cust_Created;
          case CustomersWithDescBOFieldNames.cust_Version:
            return ((CustomersWithDescBO)component).cust_Version;
          case CustomersWithDescBOFieldNames.cust_InitialPurchaseDate:
            return ((CustomersWithDescBO)component).cust_InitialPurchaseDate;
          default:
            throw new BusinessLayerException( "Field not supported." );
        }
      }
      public override void SetValue( object component, object value )
      {
        switch (this.Field)
        {
          case CustomersWithDescBOFieldNames.cust_pk:
            ((CustomersWithDescBO)component).cust_pk = (System.Int32)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Company:
            ((CustomersWithDescBO)component).cust_Company = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Prefix:
            ((CustomersWithDescBO)component).cust_Prefix = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_FirstName:
            ((CustomersWithDescBO)component).cust_FirstName = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_MiddleName:
            ((CustomersWithDescBO)component).cust_MiddleName = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_LastName:
            ((CustomersWithDescBO)component).cust_LastName = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Suffix:
            ((CustomersWithDescBO)component).cust_Suffix = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Address1:
            ((CustomersWithDescBO)component).cust_Address1 = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Address2:
            ((CustomersWithDescBO)component).cust_Address2 = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_City:
            ((CustomersWithDescBO)component).cust_City = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_State:
            ((CustomersWithDescBO)component).cust_State = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Postal:
            ((CustomersWithDescBO)component).cust_Postal = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Country:
            ((CustomersWithDescBO)component).cust_Country = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Email:
            ((CustomersWithDescBO)component).cust_Email = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_PhoneDay:
            ((CustomersWithDescBO)component).cust_PhoneDay = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_PhoneDayType:
            ((CustomersWithDescBO)component).cust_PhoneDayType = (System.Int32)value;
            break;
          case CustomersWithDescBOFieldNames.cust_PhoneNight:
            ((CustomersWithDescBO)component).cust_PhoneNight = (System.String)value;
            break;
          case CustomersWithDescBOFieldNames.cust_PhoneNightType:
            ((CustomersWithDescBO)component).cust_PhoneNightType = (System.Int32)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Created:
            ((CustomersWithDescBO)component).cust_Created = (System.DateTime)value;
            break;
          case CustomersWithDescBOFieldNames.cust_Version:
            ((CustomersWithDescBO)component).cust_Version = (System.Int32)value;
            break;
          case CustomersWithDescBOFieldNames.cust_InitialPurchaseDate:
            ((CustomersWithDescBO)component).cust_InitialPurchaseDate = (System.DateTime)value;
            break;
          default:
            throw new BusinessLayerException( "Field not supported." );
        }
      }
      public override Type ComponentType
      {
        get
        {
          return _ComponentType;
        }
      }
    }

    #endregion

  }

}
